
import { _decorator, Component, Node, Quat, math, Vec3, Mat4 } from 'cc';
import { Input, KeyCode } from '../InputManager';
import Mathf from './Mathf';
import Vector3 from './Vector3';
const { ccclass, property } = _decorator;

@ccclass('CameraFollow')
export class CameraFollow extends Component {

    @property(Node)
    public target:Node |null = null;

    @property()
    public distance:number = 15;
    
    @property()
    public height:number = 5;

    @property()
    public heightDamping:number = 3;

    @property()
    public rotationDamping:number = 3;

    start () {
        // [3]

        /*console.log("anble 1 = ",Mathf.lerpAngle(350,360,0.5));
        console.log("anble 1 = ",Mathf.lerpAngle(350,20,0.5));
        console.log("anble 1 = ",Mathf.lerpAngle(5,-30,0.5));*/

        /*var axis:Vec3 = new Vec3();

        var quat:Quat = new Quat();

        Quat.toAxisZ(axis,Quat.fromEuler(quat,0,90,0));

        console.log("dir 1 = ",this.rotateTo(new Vec3(0,0,1),90),axis);

        Quat.toAxisZ(axis,Quat.fromEuler(quat,0,-90,0));
        console.log("dir 2 = ",this.rotateTo(new Vec3(0,0,1),-90),axis);

        Quat.toAxisZ(axis,Quat.fromEuler(quat,0,45,0));
        console.log("dir 3 = ",this.rotateTo(new Vec3(0,0,1),45),axis);

        Quat.toAxisZ(axis,Quat.fromEuler(quat,0,125,0));
        console.log("dir 4 = ",this.rotateTo(new Vec3(0,0,1),125),axis);*/
        

    }

    update (deltaTime: number) {
    
        //if(Input.getKeyDown(KeyCode.Q))
        //{
            if(this.target)
            {
                var worldEulerAngle:Vec3 = new Vec3();
                this.target.worldRotation.getEulerAngles(worldEulerAngle);

                var wantedRotationAngle:number = worldEulerAngle.y + 180; //因为forward是 -z 所以 + 180
                var wantedHeight:number = this.target.worldPosition.y + this.height;
    
                var currentRotationAngle:number = this.node.eulerAngles.y;
                var currentHeight:number = this.node.worldPosition.y;
    
                currentRotationAngle = Mathf.lerpAngle(currentRotationAngle,wantedRotationAngle,this.rotationDamping * deltaTime);
                //currentRotationAngle = wantedRotationAngle;
                currentHeight = Mathf.lerp(currentHeight,wantedHeight,this.heightDamping * deltaTime);


                var currentDir = this.rotateTo(new Vec3(0,0,1),currentRotationAngle);

                /*var axis:Vec3 = new Vec3();

                var quat:Quat = new Quat();

                Quat.toAxisZ(axis,Quat.fromEuler(quat,0,currentRotationAngle,0));

                currentDir = axis*/
    
                currentDir = Vector3.mul(currentDir,this.distance);
                
    
                var pos:Vec3 = this.target.worldPosition;
    
                var bsePos = pos;
                pos = Vector3.add(pos,currentDir);
    
                pos.y = currentHeight;
    
                this.node.worldPosition = pos;
    
    
                this.node.lookAt(this.target.worldPosition);

    
            }
        //}

        

    }

    public rotateTo(from:Vec3, angle:number):Vec3
    {

        var radian:number = angle * Math.PI / 180; //获得弧度

        var rotateMatrix:Mat4 = new Mat4();

        rotateMatrix.rotate(radian,new Vec3(0,1,0));
        
        //var v4:Vec4 = new Vec4(from.x,from.y,from.z,0);

        //console.log("rotateMatrix",rotateMatrix.toString());

        return new Vec3(
            from.x * rotateMatrix.m00 + from.y * rotateMatrix.m04 + from.z * rotateMatrix.m08,
            from.x * rotateMatrix.m01 + from.y * rotateMatrix.m05 + from.z * rotateMatrix.m09,
            from.x * rotateMatrix.m02 + from.y * rotateMatrix.m06 + from.z * rotateMatrix.m10
            );

    }

    /**
     * 以节点的正Z轴为方向朝向目标
     * @param pos 
     * @param up 
     */
     /*public lookAtZ(pos: math.Vec3, up?: math.Vec3)
     {
       //super.lookAt(pos, up);
 
       var outDir:Vec3 = new Vec3();
       Vec3.subtract(outDir,pos,this.node.worldPosition);
       outDir.normalize();
 
       var quat:Quat = new Quat()
 
       Quat.fromViewUp(quat,outDir.normalize(),up);
       this.node.rotation = quat;
     }*/
}

/**
 * [1] Class member could be defined like this.
 * [2] Use `property` decorator if your want the member to be serializable.
 * [3] Your initialization goes here.
 * [4] Your update function goes here.
 *
 * Learn more about scripting: https://docs.cocos.com/creator/3.0/manual/en/scripting/
 * Learn more about CCClass: https://docs.cocos.com/creator/3.0/manual/en/scripting/ccclass.html
 * Learn more about life-cycle callbacks: https://docs.cocos.com/creator/3.0/manual/en/scripting/life-cycle-callbacks.html
 */
