
import { _decorator, Component, Node, Enum, Vec2, Vec3, Quat } from 'cc';
import { GameController } from './GameController';
const { ccclass, property } = _decorator;

export enum RotationAxes
{
    MouseXAndY = 0, 
    MouseX = 1, 
    MouseY = 2
}

@ccclass('MouseLook')
export class MouseLook extends Component {
    
    @property({type:Enum(RotationAxes)})
    public axes:RotationAxes = RotationAxes.MouseXAndY;

    public sensitivityX:number = 10;
	public sensitivityY:number = 10;

    public minimumX = -360;
	public maximumX = 360;

	public minimumY = -60;
	public maximumY = 60;

    start () {
        // [3]
        
    }

    update (deltaTime: number) {
        // [4]

        if(this.axes == RotationAxes.MouseX)
        {
            var eulerAngles:Vec3 = this.node.eulerAngles;
            eulerAngles.z = 0;
            eulerAngles.y -= GameController.instance.mouseAxis.x * this.sensitivityX * deltaTime;
            this.node.eulerAngles = eulerAngles;
        }else if(this.axes == RotationAxes.MouseY)
        {
            var eulerAngles:Vec3 = this.node.eulerAngles;
            eulerAngles.z = 0;
            eulerAngles.x -= GameController.instance.mouseAxis.y * this.sensitivityY * deltaTime;

            if(eulerAngles.x < this.minimumY)
            {
                eulerAngles.x = this.minimumY;
            }

            if(eulerAngles.x > this.maximumY)
            {
                eulerAngles.x = this.maximumY;
            }

            this.node.eulerAngles = eulerAngles;
        }else
        {
            var eulerAngles:Vec3 = this.node.eulerAngles;

            eulerAngles.z = 0;

            eulerAngles.y -= GameController.instance.mouseAxis.x * this.sensitivityX * deltaTime;

            eulerAngles.x -= GameController.instance.mouseAxis.y * this.sensitivityY * deltaTime;

            if(eulerAngles.x < this.minimumY)
            {
                eulerAngles.x = this.minimumY;
            }

            if(eulerAngles.x > this.maximumY)
            {
                eulerAngles.x = this.maximumY;
            }


            this.node.eulerAngles = eulerAngles;
        }

    }
}

/**
 * [1] Class member could be defined like this.
 * [2] Use `property` decorator if your want the member to be serializable.
 * [3] Your initialization goes here.
 * [4] Your update function goes here.
 *
 * Learn more about scripting: https://docs.cocos.com/creator/3.0/manual/en/scripting/
 * Learn more about CCClass: https://docs.cocos.com/creator/3.0/manual/en/scripting/ccclass.html
 * Learn more about life-cycle callbacks: https://docs.cocos.com/creator/3.0/manual/en/scripting/life-cycle-callbacks.html
 */
