
import { _decorator, Component, Node, Button, EventTouch, director } from 'cc';
const { ccclass, property } = _decorator;

@ccclass('UIDemo')
export class UIDemo extends Component {
    // [1]
    // dummy = '';

    // [2]
    // @property
    // serializableDummy = 0;

    @property(Button)
    public fpDemoBtn:Button | null = null;

    @property(Button)
    public tpDemoBtn:Button | null = null;

    start () {
        // [3]

        if(this.fpDemoBtn)
        {
            this.fpDemoBtn.node.on(Node.EventType.TOUCH_START,(event:EventTouch)=>
            {
                director.loadScene("FirstPersonDemo");
            });
        }

        if(this.tpDemoBtn)
        {
            this.tpDemoBtn.node.on(Node.EventType.TOUCH_START,(event:EventTouch)=>
            {
                director.loadScene("ThirdPersonDemo");
            });
        }
        
    }

    // update (deltaTime: number) {
    //     // [4]
    // }
}

/**
 * [1] Class member could be defined like this.
 * [2] Use `property` decorator if your want the member to be serializable.
 * [3] Your initialization goes here.
 * [4] Your update function goes here.
 *
 * Learn more about scripting: https://docs.cocos.com/creator/3.0/manual/en/scripting/
 * Learn more about CCClass: https://docs.cocos.com/creator/3.0/manual/en/scripting/ccclass.html
 * Learn more about life-cycle callbacks: https://docs.cocos.com/creator/3.0/manual/en/scripting/life-cycle-callbacks.html
 */
