System.register(["cc"], function (_export, _context) {
  "use strict";

  var _cclegacy, _decorator, Component, systemEvent, Node, Vec2, game, SystemEvent, view, UITransform, Input, _dec, _class, _class2, _crd, ccclass, property, InputManager, KeyStatus, KeyCode;

  _export({
    Input: void 0,
    KeyStatus: void 0,
    KeyCode: void 0
  });

  return {
    setters: [function (_cc) {
      _cclegacy = _cc.cclegacy;
      _decorator = _cc._decorator;
      Component = _cc.Component;
      systemEvent = _cc.systemEvent;
      Node = _cc.Node;
      Vec2 = _cc.Vec2;
      game = _cc.game;
      SystemEvent = _cc.SystemEvent;
      view = _cc.view;
      UITransform = _cc.UITransform;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "78634XsIkhIEJLB1Ch5GIek", "InputManager", undefined);

      // Learn TypeScript:
      //  - [Chinese] https://docs.cocos.com/creator/manual/zh/scripting/typescript.html
      //  - [English] http://www.cocos2d-x.org/docs/creator/manual/en/scripting/typescript.html
      // Learn Attribute:
      //  - [Chinese] https://docs.cocos.com/creator/manual/zh/scripting/reference/attributes.html
      //  - [English] http://www.cocos2d-x.org/docs/creator/manual/en/scripting/reference/attributes.html
      // Learn life-cycle callbacks:
      //  - [Chinese] https://docs.cocos.com/creator/manual/zh/scripting/life-cycle-callbacks.html
      //  - [English] http://www.cocos2d-x.org/docs/creator/manual/en/scripting/life-cycle-callbacks.html
      ({
        ccclass,
        property
      } = _decorator);

      _export("Input", Input = class Input {
        /**
         * 游戏从运行开始经历的时间
         */

        /*public static getAxis(axisName:string):Vec2
        {
            return this.axis;
        }*/

        /**
         * 获得键盘按键按下状态
         */
        static getKeyDown(keyCode) {
          if (Input.keyDic[keyCode] == KeyStatus.keyDown) {
            return true;
          }

          return false;
        }
        /**
         * 获得键盘按键按住状态
         */


        static getKey(keyCode) {
          if (Input.keyDic[keyCode] == KeyStatus.keyDown || Input.keyDic[keyCode] == KeyStatus.press) {
            return true;
          }

          return false;
        }
        /**
         * 获得键盘按键按并释放状态
         */


        static getKeyUp(keyCode) {
          if (Input.keyDic[keyCode] == KeyStatus.keyUp) {
            return true;
          }

          return false;
        }

      });
      /**
       * 全局数据管理 跳场景传值用
       */


      Input.mousePosition = Vec2.ZERO;
      Input.axis = Vec2.ZERO;
      Input.keyDic = {};

      _export("default", InputManager = (_dec = ccclass('InputManager'), _dec(_class = (_class2 = class InputManager extends Component {
        constructor(...args) {
          super(...args);
          this.discardKeyList = [];
          this.axisDir = new Vec2(0, 0);
        }

        static get instance() {
          if (this._instance == null) {
            var node = new Node("InputManager");
            node.addComponent(UITransform);
            game.addPersistRootNode(node);
            this._instance = node.addComponent(InputManager);

            this._instance.init();
          }

          return this._instance;
        }

        init() {}

        onLoad() {
          this.node.getComponent(UITransform).setContentSize(view.getVisibleSize());
          systemEvent.on(SystemEvent.EventType.KEY_DOWN, this.onKeyDown, this);
          systemEvent.on(SystemEvent.EventType.KEY_UP, this.onKeyUp, this);
        }

        start() {
          /*this.node.width = 5000;
          this.node.height = 5000;
          this.node.x = winSize.width / 2;
          this.node.y = winSize.height / 2;
            this.node.on(Node.EventType.TOUCH_START,(event:Event.EventTouch)=>
          {
              event.bubbles = true;
              event.stopPropagation();
          
              log("点击鼠标",event.getLocation());
            },this,false);*/
        }
        /**
         * 启动输入管理
         */


        startup() {
          console.log("InputManager 启动输入管理"); //log("keycode?? ",macro.KEY.num0,macro.KEY.num1,macro.KEY.num3)
        }

        onKeyDown(event) {
          var keyCode = event.keyCode; //console.log("keycode ",keyCode);

          if (event.keyCode >= 48 && event.keyCode <= 57) {
            keyCode += 48;
          }

          if (!Input.keyDic[keyCode]) {
            Input.keyDic[keyCode] = KeyStatus.keyDown;
          }
        }

        onKeyUp(event) {
          var keyCode = event.keyCode;

          if (event.keyCode >= 48 && event.keyCode <= 57) {
            keyCode += 48;
          }

          Input.keyDic[keyCode] = KeyStatus.keyUp;
        }

        update(dt) {
          this.axisDir.x = 0;
          this.axisDir.y = 0;

          if (Input.getKey(KeyCode.LeftArrow) || Input.getKey(KeyCode.A)) {
            this.axisDir.x = -1;
          }

          if (Input.getKey(KeyCode.RightArrow) || Input.getKey(KeyCode.D)) {
            this.axisDir.x = 1;
          }

          if (Input.getKey(KeyCode.UpArrow) || Input.getKey(KeyCode.W)) {
            this.axisDir.y = 1;
          }

          if (Input.getKey(KeyCode.DownArrow) || Input.getKey(KeyCode.S)) {
            this.axisDir.y = -1;
          }

          Input.axis = this.axisDir;
        }

        lateUpdate() {
          for (var i = 0; i < this.discardKeyList.length; i++) {
            delete Input.keyDic[this.discardKeyList[i]];
          }

          this.discardKeyList.length = 0;

          for (var keyCode in Input.keyDic) {
            if (Input.keyDic[keyCode] == KeyStatus.keyDown) {
              Input.keyDic[keyCode] = KeyStatus.press;
            }

            if (Input.keyDic[keyCode] == KeyStatus.keyUp) {
              Input.keyDic[keyCode] = KeyStatus.none;
              this.discardKeyList.push(Number(keyCode));
            }
          }
        }

      }, _class2._instance = void 0, _class2)) || _class));

      if (!CC_EDITOR) {
        InputManager.instance.startup(); //启动输入管理
      }

      (function (KeyStatus) {
        KeyStatus[KeyStatus["none"] = 0] = "none";
        KeyStatus[KeyStatus["keyDown"] = 1] = "keyDown";
        KeyStatus[KeyStatus["press"] = 2] = "press";
        KeyStatus[KeyStatus["keyUp"] = 3] = "keyUp";
      })(KeyStatus || _export("KeyStatus", KeyStatus = {}));

      (function (KeyCode) {
        KeyCode[KeyCode["None"] = 0] = "None";
        KeyCode[KeyCode["Enter"] = 13] = "Enter";
        KeyCode[KeyCode["Shift"] = 16] = "Shift";
        KeyCode[KeyCode["Ctrl"] = 17] = "Ctrl";
        KeyCode[KeyCode["Alt"] = 18] = "Alt";
        KeyCode[KeyCode["Escape"] = 27] = "Escape";
        KeyCode[KeyCode["Space"] = 32] = "Space";
        KeyCode[KeyCode["LeftArrow"] = 37] = "LeftArrow";
        KeyCode[KeyCode["UpArrow"] = 38] = "UpArrow";
        KeyCode[KeyCode["RightArrow"] = 39] = "RightArrow";
        KeyCode[KeyCode["DownArrow"] = 40] = "DownArrow";
        KeyCode[KeyCode["A"] = 65] = "A";
        KeyCode[KeyCode["B"] = 66] = "B";
        KeyCode[KeyCode["C"] = 67] = "C";
        KeyCode[KeyCode["D"] = 68] = "D";
        KeyCode[KeyCode["E"] = 69] = "E";
        KeyCode[KeyCode["F"] = 70] = "F";
        KeyCode[KeyCode["G"] = 71] = "G";
        KeyCode[KeyCode["H"] = 72] = "H";
        KeyCode[KeyCode["I"] = 73] = "I";
        KeyCode[KeyCode["J"] = 74] = "J";
        KeyCode[KeyCode["K"] = 75] = "K";
        KeyCode[KeyCode["L"] = 76] = "L";
        KeyCode[KeyCode["M"] = 77] = "M";
        KeyCode[KeyCode["N"] = 78] = "N";
        KeyCode[KeyCode["O"] = 79] = "O";
        KeyCode[KeyCode["P"] = 80] = "P";
        KeyCode[KeyCode["Q"] = 81] = "Q";
        KeyCode[KeyCode["R"] = 82] = "R";
        KeyCode[KeyCode["S"] = 83] = "S";
        KeyCode[KeyCode["T"] = 84] = "T";
        KeyCode[KeyCode["U"] = 85] = "U";
        KeyCode[KeyCode["V"] = 86] = "V";
        KeyCode[KeyCode["W"] = 87] = "W";
        KeyCode[KeyCode["X"] = 88] = "X";
        KeyCode[KeyCode["Y"] = 89] = "Y";
        KeyCode[KeyCode["Z"] = 90] = "Z";
        KeyCode[KeyCode["F1"] = 112] = "F1";
        KeyCode[KeyCode["F2"] = 113] = "F2";
        KeyCode[KeyCode["F3"] = 114] = "F3";
        KeyCode[KeyCode["F4"] = 115] = "F4";
        KeyCode[KeyCode["F5"] = 116] = "F5";
        KeyCode[KeyCode["F6"] = 117] = "F6";
        KeyCode[KeyCode["F7"] = 118] = "F7";
        KeyCode[KeyCode["F8"] = 119] = "F8";
        KeyCode[KeyCode["F9"] = 120] = "F9";
        KeyCode[KeyCode["F10"] = 121] = "F10";
        KeyCode[KeyCode["F11"] = 122] = "F11";
        KeyCode[KeyCode["F12"] = 123] = "F12";
        KeyCode[KeyCode["Num0"] = 96] = "Num0";
        KeyCode[KeyCode["Num1"] = 97] = "Num1";
        KeyCode[KeyCode["Num2"] = 98] = "Num2";
        KeyCode[KeyCode["Num3"] = 99] = "Num3";
        KeyCode[KeyCode["Num4"] = 100] = "Num4";
        KeyCode[KeyCode["Num5"] = 101] = "Num5";
        KeyCode[KeyCode["Num6"] = 102] = "Num6";
        KeyCode[KeyCode["Num7"] = 103] = "Num7";
        KeyCode[KeyCode["Num8"] = 104] = "Num8";
        KeyCode[KeyCode["Num9"] = 105] = "Num9";
      })(KeyCode || _export("KeyCode", KeyCode = {}));

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=ab975e3aa2a042cb2f5b0061381df8c2412519bc.js.map